# Enum rustc_mir_build::build::matches::TestKind

source ·

    enum TestKind<'tcx> {
        Switch {
            adt_def: AdtDef<'tcx>,
            variants: BitSet<VariantIdx>,
        },
        SwitchInt {
            switch_ty: Ty<'tcx>,
            options: FxIndexMap<Const<'tcx>, u128>,
        },
        Eq {
            value: Const<'tcx>,
            ty: Ty<'tcx>,
        },
        Range(Box<PatRange<'tcx>>),
        Len {
            len: u64,
            op: BinOp,
        },
    }

Expand description

See `Test` for more.

## Variants§

§

### Switch

#### Fields

§`adt_def: AdtDef<'tcx>`

The enum type being tested.

§`variants: BitSet<VariantIdx>`

The set of variants that we should create a branch for. We also create an additional “otherwise” case.

Test what enum variant a value is.

§

### SwitchInt

#### Fields

§`switch_ty: Ty<'tcx>`

The type of the value that we’re testing.

§`options: FxIndexMap<Const<'tcx>, u128>`

The (ordered) set of values that we test for.

For integers and `char`s we create a branch to each of the values in `options`, as well as an “otherwise” branch for all other values, even in the (rare) case that `options` is exhaustive.

For `bool` we always generate two edges, one for `true` and one for `false`.

Test what value an integer, `bool`, or `char` has.

§

### Eq

#### Fields

§`value: Const<'tcx>`
§`ty: Ty<'tcx>`

Test for equality with value, possibly after an unsizing coercion to `ty`,

§

### Range(Box<PatRange<'tcx>>)

Test whether the value falls within an inclusive or exclusive range.

§

### Len

#### Fields

§`len: u64`
§`op: BinOp`

Test that the length of the slice is equal to `len`.

## Trait Implementations§

source§

### impl<'tcx> Clone for TestKind<'tcx>

source§

#### fn clone(&self) -> TestKind<'tcx>

Returns a copy of the value. Read more
1.0.0 · source§

#### fn clone_from(&mut self, source: &Self)

Performs copy-assignment from `source`. Read more
source§

### impl<'tcx> Debug for TestKind<'tcx>

source§

#### fn fmt(&self, f: &mut Formatter<'_>) -> Result

Formats the value using the given formatter. Read more
source§

### impl<'tcx> PartialEq for TestKind<'tcx>

source§

#### fn eq(&self, other: &TestKind<'tcx>) -> bool

This method tests for `self` and `other` values to be equal, and is used by `==`.
1.0.0 · source§

#### fn ne(&self, other: &Rhs) -> bool

This method tests for `!=`. The default implementation is almost always sufficient, and should not be overridden without very good reason.
source§

### impl<'tcx> StructuralPartialEq for TestKind<'tcx>

## Auto Trait Implementations§

§

### impl<'tcx> !RefUnwindSafe for TestKind<'tcx>

§

### impl<'tcx> Send for TestKind<'tcx>

§

### impl<'tcx> Sync for TestKind<'tcx>

§

### impl<'tcx> Unpin for TestKind<'tcx>

§

### impl<'tcx> !UnwindSafe for TestKind<'tcx>

## Blanket Implementations§

source§

### impl<T> Any for T
where T: 'static + ?Sized,

source§

#### fn type_id(&self) -> TypeId

Gets the `TypeId` of `self`. Read more
source§

### impl<T> Borrow<T> for T
where T: ?Sized,

source§

#### fn borrow(&self) -> &T

Immutably borrows from an owned value. Read more
source§

### impl<T> BorrowMut<T> for T
where T: ?Sized,

source§

#### fn borrow_mut(&mut self) -> &mut T

Mutably borrows from an owned value. Read more
source§

### impl<T> From<T> for T

source§

#### fn from(t: T) -> T

Returns the argument unchanged.

source§

### impl<T, U> Into<U> for T
where U: From<T>,

source§

#### fn into(self) -> U

Calls `U::from(self)`.

That is, this conversion is whatever the implementation of `From<T> for U` chooses to do.

source§

### impl<T> ToOwned for T
where T: Clone,

§

#### type Owned = T

The resulting type after obtaining ownership.
source§

#### fn to_owned(&self) -> T

Creates owned data from borrowed data, usually by cloning. Read more
source§

#### fn clone_into(&self, target: &mut T)

Uses borrowed data to replace owned data, usually by cloning. Read more
source§

### impl<T, U> TryFrom<U> for T
where U: Into<T>,

§

#### type Error = Infallible

The type returned in the event of a conversion error.
source§

#### fn try_from(value: U) -> Result<T, <T as TryFrom<U>>::Error>

Performs the conversion.
source§

### impl<T, U> TryInto<U> for T
where U: TryFrom<T>,

§

#### type Error = <U as TryFrom<T>>::Error

The type returned in the event of a conversion error.
source§

#### fn try_into(self) -> Result<U, <U as TryFrom<T>>::Error>

Performs the conversion.

## Layout§

Note: Most layout information is completely unstable and may even differ between compilations. The only exception is types with certain `repr(...)` attributes. Please see the Rust Reference's “Type Layout” chapter for details on type layout guarantees.

Size: 64 bytes

Size for each variant:

- `Switch`: 48 bytes
- `SwitchInt`: 64 bytes
- `Eq`: 56 bytes
- `Range`: 16 bytes
- `Len`: 24 bytes